//-*-C++-*-
/*
**************************************************************************
                                 description
                             --------------------
    copyright            : (C) 2002 by Luis Carvalho
    email                : lpassos@mail.telepac.pt
**************************************************************************

**************************************************************************
*                                                                        *
*  This program is free software; you can redistribute it and/or modify  *
*  it under the terms of the GNU General Public License as published by  *
*  the Free Software Foundation; either version 2 of the License, or     *
*  (at your option) any later version.                                   *
*                                                                        *
**************************************************************************/

#ifndef PMLIBRARYOBJECTEDIT_H
#define PMLIBRARYOBJECTEDIT_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kdialogbase.h>

class QLineEdit;
class QTextEdit;
class QListBox;
class PMLibraryObject;

/** 
 * This class provides a dialog to edit the definitions of a library object.
 */
class PMLibraryObjectEdit: public KDialogBase
{
   Q_OBJECT
public:
   /**
    * Construct a dialog to edit the properties of obj. The object will be
    * modified only if Ok is pressed.
    */
   PMLibraryObjectEdit( PMLibraryObject* obj, QWidget *parent, const char* name );

   static void saveConfig( KConfig* cfg );
   static void restoreConfig( KConfig* cfg );
   static QSize s_size;

private slots:
   void slotOk( );
   void slotEditsChanged( const QString& str );
   void slotDescriptionChanged( );
   void slotAddKeywordPressed( );
   void slotRemoveKeywordPressed( );
   void slotPreviewPressed( );
   void resizeEvent( QResizeEvent *ev );

private:
   PMLibraryObject* m_pObject;
   QLineEdit*       m_pNameEdit;
   QLineEdit*       m_pTypeEdit;
   QTextEdit*       m_pDescriptionEdit;
   QPushButton*     m_pPreviewEdit;
   QListBox*        m_pKeywordsList;
   QLineEdit*       m_pKeywordEdit;
   QPushButton*     m_pKeywordAdd;
   QPushButton*     m_pKeywordRemove;
};

#endif
